### R code from vignette source 'abn.Rnw'

###################################################
### code chunk number 1: abn.Rnw:68-94
###################################################
library(abn);# load library
bin.nodes<-c(1,3,4,6,9,10,11,12,15,18,19,20,21,26,27,28,32); 
var33.cat<-var33[,bin.nodes];#categorical nodes only
mydag<-matrix(c(
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v1
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v3
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v4  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v6  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v9  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v10  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v11  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v12  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v15  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v18 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v19
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v20 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v21 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v26 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v27 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v28 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0  #v32 
              ),byrow=TRUE,ncol=17); 
colnames(mydag)<-rownames(mydag)<-names(var33.cat);#set names
## now fit the model defined in mydag - full independence model
fitbn (data.df=var33.cat, dag.m=mydag,useK2=TRUE);
# this is the network score goodness of fit = log marginal likelihood


###################################################
### code chunk number 2: abn.Rnw:97-105
###################################################
# now fit model with some conditional dependencies let v11 
## depend jointly on v12 and v10
mydag["v11","v12"]<-1;
mydag["v11","v10"]<-1;
## let v4 depend on v3
mydag["v4","v3"]<-1;
fitbn (data.df=var33.cat, dag.m=mydag,useK2=TRUE);
# network score for a model with conditional independence


###################################################
### code chunk number 3: abn.Rnw:108-111
###################################################
tographviz(dag=mydag,data.df=var33.cat,outfile="mydag.dot");#create file
# mydag.dot can then be processed with graphviz
# unix shell "dot -Tpdf mydag.dot -o mydag.pdf" or use gedit if on Windows


###################################################
### code chunk number 4: abn.Rnw:125-132
###################################################
## move back to independence model
mydag["v11","v12"]<-0;mydag["v11","v10"]<-0;mydag["v4","v3"]<-0;
fitabn (data.df=var33.cat,dag.m=mydag,verbose=TRUE);
# now fit the model with some conditional dependencies 
mydag["v11","v12"]<-1;mydag["v11","v10"]<-1;mydag["v4","v3"]<-1;
fitabn (data.df=var33.cat, dag.m=mydag,verbose=TRUE);
# network score for a model with conditional independence


###################################################
### code chunk number 5: abn.Rnw:137-161
###################################################
var33.cts<-var33[,-bin.nodes];#drop categorical nodes
mydag<-matrix(c(
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v2
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v5  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v7  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v8 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v13  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v14  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v16  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v17  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v22 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v23
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v24 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v25 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v29 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v30 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v31 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0  #v33 
              ),byrow=TRUE,ncol=16); 
colnames(mydag)<-rownames(mydag)<-names(var33.cts);#set names
## now fit the model defined in mydag - full independence
fitabn (data.df=var33.cts,dag.m=mydag,verbose=TRUE);
## uses default priors of N(mu=0,var=1000), 1/var=Gamma(0.001,1/0.001)
# this is the network score goodness of fit = log marginal likelihood


###################################################
### code chunk number 6: abn.Rnw:164-174
###################################################
# now fit model with some conditional dependencies let v33 
## depend on v31, and v24 depend on 23, and v14 depend on v13
mydag["v33","v31"]<-1;
mydag["v24","v23"]<-1;
mydag["v14","v13"]<-1;
fitabn (data.df=var33.cts, dag.m=mydag,verbose=TRUE);
# network score for a model with conditional independence
tographviz(dag=mydag,data.df=var33.cts,outfile="mydagcts.dot");#create file
# mydag.dot can then be processed with graphviz
# unix shell "dot -Tpdf mydagcts.dot -o mydagcts.pdf" or use gedit if on Windows


###################################################
### code chunk number 7: abn.Rnw:185-223
###################################################
mydag<-matrix(c(
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#1
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#2  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#3  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#4  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#5  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#6  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#7  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#8  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#9  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#10 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#11 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#12 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#13 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#14 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#15 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#16 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#17 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#18 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#19 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#20 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#21 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#22 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#23 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#24 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#25 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#26 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#27 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#28 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#29 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#30
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#31
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#32 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 #33
                                               ),byrow=TRUE,ncol=33); 
colnames(mydag)<-rownames(mydag)<-names(var33);#set names
## now fit the model defined in mydag - full independence
fitabn (data.df=var33,dag.m=mydag,verbose=TRUE);


###################################################
### code chunk number 8: abn.Rnw:226-256
###################################################
# define a model with many independencies
mydag[2,1]<-1;
mydag[4,3]<-1;
mydag[6,4]<-1; mydag[6,7]<-1;
mydag[5,6]<-1;
mydag[7,8]<-1;  
mydag[8,9]<-1;
mydag[9,10]<-1;
mydag[11,10]<-1; mydag[11,12]<-1; mydag[11,19]<-1;
mydag[14,13]<-1;
mydag[17,16]<-1;mydag[17,20]<-1;
mydag[15,14]<-1; mydag[15,21]<-1;
mydag[18,20]<-1;
mydag[19,20]<-1;
mydag[21,20]<-1;
mydag[22,21]<-1;
mydag[23,21]<-1;
mydag[24,23]<-1;
mydag[25,23]<-1; mydag[25,26]<-1;
mydag[26,20]<-1;
mydag[33,31]<-1;
mydag[33,31]<-1;
mydag[32,21]<-1; mydag[32,31]<-1;mydag[32,29]<-1;    
mydag[30,29]<-1;
mydag[28,27]<-1; mydag[28,29]<-1;mydag[28,31]<-1;       
fitabn (data.df=var33, dag.m=mydag);
# network score for a model with conditional independence
tographviz(dag=mydag,data.df=var33,outfile="mydag_all.dot");#create file
# mydag.dot can then be processed with graphviz
# unix shell "dot -Tpdf mydag_all.dot -o mydag_all.pdf" or use gedit if on Windows


###################################################
### code chunk number 9: abn.Rnw:275-309
###################################################
bin.nodes<-c(1,3,4,6,9,10,11,12,15,18,19,20,21,26,27,28,32); 
var33.cat<-var33[,bin.nodes];#categorical nodes only
mydag<-matrix(c(
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v1
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v3
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v4  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v6  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v9  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v10  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v11  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v12  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v15  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v18 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v19
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v20 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v21 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v26 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v27 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v28 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0  #v32 
              ),byrow=TRUE,ncol=17); 
colnames(mydag)<-rownames(mydag)<-names(var33.cat);#set names
## create empty DAGs
banned.cat<-matrix(rep(0,dim(var33.cat)[2]^2),ncol=dim(var33.cat)[2]);
colnames(banned.cat)<-rownames(banned.cat)<-names(var33.cat);#set names
retain.cat<-matrix(rep(0,dim(var33.cat)[2]^2),ncol=dim(var33.cat)[2]);
colnames(retain.cat)<-rownames(retain.cat)<-names(var33.cat);#set names
start.cat<-matrix(rep(0,dim(var33.cat)[2]^2),ncol=dim(var33.cat)[2]);
colnames(start.cat)<-rownames(start.cat)<-names(var33.cat);#set names
myres<-searchbn(data.df=var33.cat,
                banned.m=banned.cat,
                retain.m=retain.cat,
                start.m=start.cat,
                useK2=TRUE,max.parents=2,init.permuts=0,db.size=1000);


###################################################
### code chunk number 10: abn.Rnw:315-322
###################################################
## just use default priors 
myres.add<-searchabn(data.df=var33.cat,
                 banned.m=banned.cat,
                 retain.m=retain.cat,
                 start.m=start.cat,
                 max.parents=2, 
                 init.permuts=0,db.size=1000,error.verbose=TRUE);


###################################################
### code chunk number 11: abn.Rnw:327-360
###################################################
var33.cts<-var33[,-bin.nodes];#drop categorical nodes
mydag<-matrix(c(
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v2
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v5  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v7  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v8 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v13  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v14  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v16  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v17  
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v22 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v23
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v24 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v25 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v29 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v30 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, #v31 
                 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0  #v33 
              ),byrow=TRUE,ncol=16); 
colnames(mydag)<-rownames(mydag)<-names(var33.cts);#set names
banned.cts<-matrix(rep(0,dim(var33.cts)[2]^2),ncol=dim(var33.cts)[2]);
colnames(banned.cts)<-rownames(banned.cts)<-names(var33.cts);#set names
retain.cts<-matrix(rep(0,dim(var33.cts)[2]^2),ncol=dim(var33.cts)[2]);
colnames(retain.cts)<-rownames(retain.cts)<-names(var33.cts);#set names
start.cts<-matrix(rep(0,dim(var33.cts)[2]^2),ncol=dim(var33.cts)[2]);
colnames(start.cts)<-rownames(start.cts)<-names(var33.cts);#set names
#
myres.add<-searchabn(data.df=var33.cts,
                 banned.m=banned.cts,
                 retain.m=retain.cts,
                 start.m=start.cts,
                 max.parents=2, 
                 init.permuts=0,db.size=1000,error.verbose=TRUE);


###################################################
### code chunk number 12: abn.Rnw:366-424
###################################################
mydag<-matrix(c(
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#1
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#2  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#3  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#4  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#5  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#6  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#7  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#8  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#9  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#10 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#11 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#12 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#13 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#14 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#15 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#16 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#17 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#18 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#19 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#20 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#21 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#22 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#23 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#24 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#25 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#26 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#27 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#28 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#29 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#30
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#31
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#32 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 #33
                                               ),byrow=TRUE,ncol=33); 
colnames(mydag)<-rownames(mydag)<-names(var33);#set names
## create empty DAGs
banned<-matrix(rep(0,dim(var33)[2]^2),ncol=dim(var33)[2]);
colnames(banned)<-rownames(banned)<-names(var33);#set names
retain<-matrix(rep(0,dim(var33)[2]^2),ncol=dim(var33)[2]);
colnames(retain)<-rownames(retain)<-names(var33);#set names
start<-matrix(rep(0,dim(var33)[2]^2),ncol=dim(var33)[2]);
colnames(start)<-rownames(start)<-names(var33);#set names

## giving diffuse priors - same as default but explicitly stated
myres.add<-searchabn(data.df=var33,
                 banned.m=banned,
                 retain.m=retain,
                 start.m=start,
                 hyper.params=list(
                                   mean=rep(0,dim(var33)[2]+1),
                                   sd=rep(sqrt(1000),dim(var33)[2]+1), 
                                   shape=rep(0.001,16),## 16 Gaussian nodes
                                   scale=rep(1/0.001,16)## 16 Gaussian nodes
                 ),
                 max.parents=2, 
                 init.permuts=0,db.size=10000,
                 error.verbose=TRUE,enforce.db.size=TRUE);


###################################################
### code chunk number 13: abn.Rnw:434-494
###################################################
mydag<-matrix(c(
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#1
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#2  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#3  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#4  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#5  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#6  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#7  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#8  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#9  
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#10 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#11 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#12 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#13 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#14 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#15 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#16 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#17 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#18 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#19 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#20 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#21 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#22 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#23 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#24 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#25 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#26 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#27 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#28 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#29 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#30
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#31
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#32 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 #33
                                               ),byrow=TRUE,ncol=33); 
colnames(mydag)<-rownames(mydag)<-names(var33);#set names
## create empty DAGs
banned<-matrix(rep(0,dim(var33)[2]^2),ncol=dim(var33)[2]);
colnames(banned)<-rownames(banned)<-names(var33);#set names
retain<-matrix(rep(0,dim(var33)[2]^2),ncol=dim(var33)[2]);
colnames(retain)<-rownames(retain)<-names(var33);#set names
start<-matrix(rep(0,dim(var33)[2]^2),ncol=dim(var33)[2]);
colnames(start)<-rownames(start)<-names(var33);#set names

set.seed(10000);## only affects init.permuts
start.list<-list();
n.searches<-10;#example only - must be much larger in practice
for(i in 1:n.searches){start.list[[i]]<-retain;} ## empty networks
myres<-hillsearchabn(data.df=var33,banned.m=banned,retain.m=retain,
                     start.m=start.list,
                     hyper.params=list(
                     mean=rep(0,dim(var33)[2]+1),
                     sd=rep(sqrt(1000),dim(var33)[2]+1), 
                     shape=rep(0.001,16),## 16 Gaussian nodes
                     scale=rep(1/0.001,16)## 16 Gaussian nodes
                     ),
                     max.parents=2, 
                     num.searches=n.searches,
                     init.permuts=20,db.size=20000,
                     localdb=TRUE,timing=TRUE);


###################################################
### code chunk number 14: abn.Rnw:506-526
###################################################
# use results from above searches which are stored in ``myres''
#step 1. discard any duplicate searches (these are unlikely)
indexes<-uniquenets(myres$init.dag);
all.res<-list();
all.res$init.score<-myres$init.score[indexes];
all.res$final.score<-myres$final.score[indexes];
all.res$init.dag.<-myres$init.dag[indexes];
all.res$final.dag<-myres$final.dag[indexes];
# for every possible arc calculate how many times it appears in the searches  
mypruneddags<-arcfreq(all.res$final.dag);
# now get a matrix/DAG for the majority network comprising of 1/0s
myfunc<-function(arg1,threshold,netdata){#trivial helper for apply()
         if(arg1>=round(threshold*length(netdata$final.dag)))
         {return(1);} else {return(0);}}
dag.con<-apply(mypruneddags,c(1,2),FUN=myfunc,threshold=0.51,
               netdata=all.res);
tographviz(dag=dag.con,data.df=var33,outfile="dagcon.dot");#create file
# dagcon.dot can then be processed with graphviz
# unix shell "dot -Tpdf dagcon.dot -o dagcon.pdf" or use gedit if on Windows



###################################################
### code chunk number 15: abn.Rnw:553-573
###################################################
#specific a DAG model - the model we wish to use to perform 
#parametric bootstrapping
mydag<-matrix(c(
# D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 Year Loc.x Loc.y
  0, 1, 0, 0, 0, 0, 0, 0, 0, 0,  0,   0,    0,    # D1
  0, 0, 1, 0, 0, 0, 0, 0, 0, 0,  0,   0,    0,    # D2
  0, 0, 0, 1, 0, 0, 0, 0, 0, 0,  0,   0,    0,    # D3
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0,   1,    0,    # D4
  0, 0, 0, 0, 0, 1, 0, 0, 0, 0,  0,   0,    0,    # D5
  0, 0, 0, 1, 0, 0, 0, 0, 0, 0,  0,   0,    0,    # D6
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  1,   0,    0,    # D7
  0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  0,   0,    0,    # D8
  0, 1, 0, 0, 0, 0, 0, 0, 0, 0,  0,   0,    0,    # D9
  0, 0, 0, 0, 0, 0, 0, 0, 1, 0,  0,   0,    0,    # D10
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0,   0,    0,    # Year
  0, 0, 0, 0, 0, 0, 1, 0, 0, 0,  0,   0,    0,    # Loc.x
  0, 0, 0, 0, 0, 0, 1, 0, 0, 0,  0,   0,    0     # Loc.y
                                               ),byrow=TRUE,ncol=13); 
colnames(mydag)<-rownames(mydag)<-names(pigs.1par);#set names



###################################################
### code chunk number 16: abn.Rnw:575-594
###################################################
# Node D1|D2 e.g. logit(P(D1=TRUE)=constant+coeff*D2
# first get the posterior density for the constant
marg<-getmarginal(data.df=pigs.1par,
                   dag.m=mydag,
                   whichnode="D1",
                   whichvar="constant",#this is the intercept
                     post.x=seq(from=1,to=1.7,len=1000),
                     verbose=FALSE,std=TRUE);
# get grid of discrete values x and f(x)
D1.p<-cbind(marg[,1],marg[,2]);
# now repeat for the slope term coeff
marg<-getmarginal(data.df=pigs.1par,
                   dag.m=mydag,
                   whichnode="D1",
                   whichvar="D2",#this is the slope
                     post.x=seq(from=0.6,to=1.5,len=1000),
                     verbose=FALSE,std=TRUE);
# add to existing grid x,f(x),x,f(x)
D1.p<-cbind(D1.p,marg[,1],marg[,2]);


###################################################
### code chunk number 17: abn.Rnw:599-612
###################################################
par(mar=c(8.8,8.2,3.1,3.1));
par(cex.axis=2.5);par(cex.lab=2.5);par(bg="white");par(fg="black");par(col.axis="black");par(col="black");par(col.main="black");
par(cex.main=2.5);par(col.lab="black");par(las=1);par(xaxs="i");par(yaxs="i");
par(mfrow=c(1,1));
plot(D1.p[,1],D1.p[,2],main="",xlab="",ylab="",type="n",axes=FALSE,xlim=c(0,2));
lines(D1.p[,1],D1.p[,2],col="brown",lwd=3,lty=1);
lines(D1.p[,3],D1.p[,4],col="darkblue",lwd=3,lty=6);
mtext("log odds",1,line=4,cex=2.5);
par(las=3);
mtext("Density",2,line=4.5,cex=2.5);par(las=1);
axis(1,padj=0.5,cex.axis=2.0);axis(2);box(); title("");
legend(0.5,8,legend=c("intercept node D1","effect of D2 at node D1"),cex=1.5,
 col=c("brown","darkblue"),lty=c(1,6),lwd=5,bty="n");


###################################################
### code chunk number 18: abn.Rnw:634-656
###################################################
pigs<-pigs.1par[1:50,c(2,3)];#take a subset of observations and variables
## step 1. find all the local scores within each node - this creates a "cache"
## of scores
## n.b. using a parent limit of 1 e.g we only consider DAGs with at most one 
## arc per node
mynodes.add<-allnodesabn(data.df=pigs,max.parents=1); 
## step 2. search across all orders/DAGs for the given structural feature
# specifically calculate the get posterior prob of arc 1->2 
p.2.1<-getposteriorfeaturesbn(local.scores=mynodes.add,feature="arc",child=2,
                              parent=1);
print(p.2.1);
#now for arc 2->1
p.1.2<-getposteriorfeaturesbn(local.scores=mynodes.add,feature="arc",child=1,
                              parent=2);
print(p.1.2);
## step 3. calculate the denominator - across all structural features (see text)
denom<-getposteriorfeaturesbn(local.scores=mynodes.add,feature="all");
print(denom);
## we now get the posterior probability for arc 1->2
print(p.2.1/denom);
## we now get the posterior probability for arc 2->1
print(p.1.2/denom);


###################################################
### code chunk number 19: abn.Rnw:663-694
###################################################
pigs<-pigs.1par[1:50,c(2,3)];#simple 2 node model
## step 1. find all the local scores within each node - this creates a "cache"
##                                                                   of scores
mynodes.add<-allnodesabn(data.df=pigs,max.parents=1); 
print(mynodes.add);
# now want the posterior prob. of the independence DAG (empty network)
G<-c(1,0,1,0);#empty [1][2] - this says include rows 1 and 3 in the node cache
# row 1 corresponds to node 1 having no parents and row 3 for node 2
# with no parents
DAG1<-getposteriorfeaturesbn(local.scores=mynodes.add,feature="custom",
                             featuredefn=G);
#now for DAG node 2 indep, node 1 depends on node 2
G<-c(0,1,1,0);# [1|2][2]
DAG2<-getposteriorfeaturesbn(local.scores=mynodes.add,feature="custom",
                             featuredefn=G);
#now for DAG node 1 indep, node 2 depends on node 1
G<-c(1,0,0,1);# [1][2|1]
DAG3<-getposteriorfeaturesbn(local.scores=mynodes.add,feature="custom",
                             featuredefn=G);
print(DAG1+DAG2+DAG3);#get total sum
#this equals the denominator - which it should since this is all 
#possible DAGs
denom<-getposteriorfeaturesbn(local.scores=mynodes.add,feature="all",
       child=NULL,
       parent=NULL);
print(denom);
# posterior probabilities for the 3 DAGs, [1][2], [1|2][2],[2|1][1] are
print(p1<-DAG1/denom);
print(p2<-DAG2/denom);
print(p3<-DAG3/denom);
print(p1+p2+p3);


###################################################
### code chunk number 20: abn.Rnw:698-720
###################################################
pigs<-pigs.1par[1:50,c(2,3)];#simple 2 node model
## step 1. find all the local scores within each node - this creates a "cache"
##                                                                   of scores
mynodes.add<-allnodesabn(data.df=pigs,max.parents=1); 
print(mynodes.add);
#arc 1->2, dont care about node 1 e.g. arc is marginalised over all possible
#                                                         other combinations
G<-c(1,1,0,1);
p.2.1.G<-getposteriorfeaturesbn(local.scores=mynodes.add,feature="custom",
                                featuredefn=G);
#arc 2->1, dont care about node 2
G<-c(0,1,1,1);
p.1.2.G<-getposteriorfeaturesbn(local.scores=mynodes.add,feature="custom",
                                featuredefn=G);
# now get denominator 
G<-c(1,1,1,1);
denom<-getposteriorfeaturesbn(local.scores=mynodes.add,feature="custom",
                                featuredefn=G);
print(p.2.1.G/denom);#post. prob. arc 1->2
print(p.2.1/denom);  # as calculated directly above
print(p.1.2.G/denom);#post. prob. arc 2->1
print(p.1.2/denom);  # as calculated directly above


###################################################
### code chunk number 21: abn.Rnw:730-739
###################################################
pigs<-pigs.1par[,c(1:8,12,13)];#all 9011 observation but limit to 10 variables
# using all 13 variables in pigs will take several hours of cpu time
mynodes.add<-allnodesabn(data.df=pigs,max.parents=1); 
## now for most probable network of all DAGs where each node has at
## most one arc
map.1par.10var<-findmostprobablebn(local.scores=mynodes.add,data.df=pigs);
tographviz(dag=map.1par.10var,data.df=pigs,outfile="map1_10var.dot");#create file
# mydag.dot can then be processed with graphviz
# unix shell "dot -Tpdf map1_10var.dot -o map1_10var.pdf" or use gedit if on Windows


###################################################
### code chunk number 22: abn.Rnw:749-757 (eval = FALSE)
###################################################
## pigs<-pigs.1par;#all observations all variables
## mynodes.add<-allnodesabn(data.df=pigs,max.parents=1); 
## ## now for most probable network of all DAGs where each node has at
## ## most one arc
## system.time(map.1par<-findmostprobablebn(local.scores=mynodes.add,data.df=pigs));
## tographviz(dag=map.1par,data.df=pigs,outfile="map_1par.dot");#create file
## # mydag.dot can then be processed with graphviz
## # unix shell "dot -Tpdf map_1par.dot -o map_1par.pdf" or use gedit if on Windows


